searchNodes=[{"doc":"Builder DSL to handle common ADT definition use cases","ref":"Algae.html","title":"Algae","type":"module"},{"doc":"Build a product typeIncludes:StructType definitionConstructor function (for piping and defaults)Implicit defaults for simple valuesDefinitionFor convenveniece, several variants of the DSL are available.Standarddefmodule Player do # =============== # # Data Definition # # =============== # defdata do name :: String.t() hit_points :: non_neg_integer() experience :: non_neg_integer() end # =================== # # Rest of Module # # (business as usual) # # =================== # @spec attack(t(), t()) :: {t(), t()} def attack(%{experience: xp} = player, %{hit_points: hp} = target) do { %{player | experience: xp + 50}, %{target | hit_points: hp - 10} } end end #=&gt; %Player{name: &quot;Sir Bob&quot;, hit_points: 10, experience: 500}Single Field ShorthandWithout any fields specified, Algae will default to a single field with the same name as the module (essentially a &quot;wrapper type&quot;). You must still provide the type for this field, however.Embedded in another module:defmodule Id do defdata any() end %Id{} #=&gt; %Id{id: nil}Standalone:defdata Wrapper :: any() %Wrapper{} #=&gt; %Wrapper{wrapper: nil}ConstructorA helper function, especially useful for piping. The order of arguments is the same as the order that they are defined in.defmodule Person do defdata do name :: String.t() age :: non_neg_integer() end end Person.new(&quot;Rachel Weintraub&quot;) #=&gt; %Person{ # name: &quot;Rachel Weintraub&quot;, # age: 0 # }Constructor DefaultsFields will automatically default to a sensible value (a typical &quot;zero&quot; for that datatype). For example, non_neg_integer() will default to 0, and String.t() will default to &quot;&quot;.You may also overwrite these defaults with the \\\\\\\\ syntax.defmodule Pet do defdata do name :: String.t() leg_count :: non_neg_integer() \\\\\\\\ 4 end end Pet.new(&quot;Crookshanks&quot;) #=&gt; %Pet{ # name: &quot;Crookshanks&quot;, # leg_count: 4 # } Pet.new(&quot;Paul the Psychic Octopus&quot;, 8) #=&gt; %Pet{ # name: &quot;Paul the Psychic Octopus&quot;, # leg_count: 8 # }This overwriting syntax is required for complex types:defdata Grocery do item :: {String.t(), integer(), boolean()} \\\\\\\\ {&quot;Apple&quot;, 4, false} end Grocery.new() #=&gt; %Grocery{ # item: {&quot;Apple&quot;, 4, false} # }Overwrite ConstructorThe new constructor function may be overwritten.iex&gt; defmodule Constant do ...&gt; defdata fun() ...&gt; ...&gt; def new(value), do: %Constant{constant: fn _ -&gt; value end} ...&gt; end ...&gt; ...&gt; fourty_two = Constant.new(42) ...&gt; fourty_two.constant.(33) 42Empty TagAn empty type (with no fields) is definable using the none() typedefmodule Nothing do defdata none() end Nothing.new() #=&gt; %Nothing{}","ref":"Algae.html#defdata/1","title":"Algae.defdata/1","type":"macro"},{"doc":"","ref":"Algae.html#defdata/2","title":"Algae.defdata/2","type":"macro"},{"doc":"Build a sum (coproduct) type from product typesdefmodule Light do # ============== # # Sum Definition # # ============== # defsum do defdata Red :: none() defdata Yellow :: none() defdata Green :: none() end # =================== # # Rest of Module # # (business as usual) # # =================== # def from_number(1), do: %Light.Red{} def from_number(2), do: %Light.Yellow{} def from_number(3), do: %Light.Green{} end Light.new() #=&gt; %Light.Red{}Embedded ProductsData with multiple fileds can be defined directly as part of a sumdefmodule Pet do defsum do defdata Cat do name :: String.t() claw_sharpness :: String.t() end defdata Dog do name :: String.t() bark_loudness :: non_neg_integer() end end endDefault ConstructorThe first defdata's constructor will be the default constructor for the sumdefmodule Maybe do defsum do defdata Nothing :: none() defdata Just :: any() end end Maybe.new() #=&gt; %Maybe.Nothing{}Tagged UnionsSums join existing types with tags: new types to help distibguish the context that they are in (the sum type)defdata Book :: String.t() \\\\ &quot;War and Peace&quot; defdata Video :: String.t() \\\\ &quot;2001: A Space Odyssey&quot; defmodule Media do defsum do defdata Paper :: Book.t() defdata Film :: Video.t() \\\\ Video.new(&quot;A Clockwork Orange&quot;) end end media = Media.new() #=&gt; %Paper{ # paper: %Book{ # book: &quot;War and Peace&quot; # } # }","ref":"Algae.html#defsum/1","title":"Algae.defsum/1","type":"macro"},{"doc":"","ref":"Algae.html#t:ast/0","title":"Algae.ast/0","type":"type"},{"doc":"Represent branching conditions. These could be different return types, error vs nominal value, and so on.Examplesiex&gt; require Integer ...&gt; ...&gt; even_odd = fn(value) -&gt; ...&gt; if Integer.is_even(value) do ...&gt; Algae.Either.Right.new(value) ...&gt; else ...&gt; Algae.Either.Left.new(value) ...&gt; end ...&gt; end ...&gt; ...&gt; even_odd.(10) %Algae.Either.Right{right: 10} ...&gt; even_odd.(11) %Algae.Either.Left{left: 11}","ref":"Algae.Either.html","title":"Algae.Either","type":"module"},{"doc":"","ref":"Algae.Either.html#new/0","title":"Algae.Either.new/0","type":"function"},{"doc":"","ref":"Algae.Either.html#t:t/0","title":"Algae.Either.t/0","type":"type"},{"doc":"","ref":"Algae.Either.Left.html","title":"Algae.Either.Left","type":"module"},{"doc":"Default Elixir.Algae.Either.Left struct. Value defaults to nil.","ref":"Algae.Either.Left.html#new/0","title":"Algae.Either.Left.new/0","type":"function"},{"doc":"Helper for initializing struct with a specific value","ref":"Algae.Either.Left.html#new/1","title":"Algae.Either.Left.new/1","type":"function"},{"doc":"","ref":"Algae.Either.Left.html#t:t/0","title":"Algae.Either.Left.t/0","type":"type"},{"doc":"","ref":"Algae.Either.Right.html","title":"Algae.Either.Right","type":"module"},{"doc":"Default Elixir.Algae.Either.Right struct. Value defaults to nil.","ref":"Algae.Either.Right.html#new/0","title":"Algae.Either.Right.new/0","type":"function"},{"doc":"Helper for initializing struct with a specific value","ref":"Algae.Either.Right.html#new/1","title":"Algae.Either.Right.new/1","type":"function"},{"doc":"","ref":"Algae.Either.Right.html#t:t/0","title":"Algae.Either.Right.t/0","type":"type"},{"doc":"A &quot;free&quot; structure that converts functors into monads by embedding them in a special structure with all of the monadic heavy lifting done for you.Similar to trees and lists, but with the ability to add a struct &quot;tag&quot;, at each level. Often used for DSLs, interpreters, or building structured data.For a simple introduction to the &quot;free monad + interpreter&quot; pattern, we recommend Why free monads matter.AnatomyPurePure simply holds a plain value.%Free.Pure{pure: 42}RollRoll resursively containment of more Free structures embedded in a another ADT. For example, with Id:%Free.Roll{ roll: %Id{ id: %Pure{ pure: 42 } } }","ref":"Algae.Free.html","title":"Algae.Free","type":"module"},{"doc":"Lift a plain functor up into a free monad.Examplesiex&gt; free(%Algae.Id{id: 42}) %Algae.Free.Roll{ roll: %Algae.Id{ id: %Algae.Free.Pure{ pure: 42 } } }","ref":"Algae.Free.html#free/1","title":"Algae.Free.free/1","type":"function"},{"doc":"Add another layer to a free structureExamplesiex&gt; 13 ...&gt; |&gt; new() ...&gt; |&gt; layer(%Algae.Id{}) %Algae.Free.Roll{ roll: %Algae.Id{ id: %Algae.Free.Pure{ pure: 13 } } }","ref":"Algae.Free.html#layer/2","title":"Algae.Free.layer/2","type":"function"},{"doc":"","ref":"Algae.Free.html#new/0","title":"Algae.Free.new/0","type":"function"},{"doc":"Create an Algae.Free.Pure wrapping a single, simple valueExamplesiex&gt; new(42) %Algae.Free.Pure{pure: 42}","ref":"Algae.Free.html#new/1","title":"Algae.Free.new/1","type":"function"},{"doc":"Wrap a functor in a free structure.Examplesiex&gt; wrap(%Algae.Id{id: 42}) %Algae.Free.Roll{ roll: %Algae.Id{ id: 42 } }","ref":"Algae.Free.html#wrap/1","title":"Algae.Free.wrap/1","type":"function"},{"doc":"","ref":"Algae.Free.html#t:t/0","title":"Algae.Free.t/0","type":"type"},{"doc":"","ref":"Algae.Free.Pure.html","title":"Algae.Free.Pure","type":"module"},{"doc":"Default Elixir.Algae.Free.Pure struct. Value defaults to %Witchcraft.Unit{}.","ref":"Algae.Free.Pure.html#new/0","title":"Algae.Free.Pure.new/0","type":"function"},{"doc":"Helper for initializing struct with a specific value","ref":"Algae.Free.Pure.html#new/1","title":"Algae.Free.Pure.new/1","type":"function"},{"doc":"","ref":"Algae.Free.Pure.html#t:t/0","title":"Algae.Free.Pure.t/0","type":"type"},{"doc":"","ref":"Algae.Free.Roll.html","title":"Algae.Free.Roll","type":"module"},{"doc":"Default Elixir.Algae.Free.Roll struct. Value defaults to nil.","ref":"Algae.Free.Roll.html#new/0","title":"Algae.Free.Roll.new/0","type":"function"},{"doc":"Helper for initializing struct with a specific value","ref":"Algae.Free.Roll.html#new/1","title":"Algae.Free.Roll.new/1","type":"function"},{"doc":"","ref":"Algae.Free.Roll.html#t:t/0","title":"Algae.Free.Roll.t/0","type":"type"},{"doc":"The simplest ADT: a simple wrapper for some dataExamplesiex&gt; %Algae.Id{id: &quot;hi!&quot;} %Algae.Id{id: &quot;hi!&quot;}","ref":"Algae.Id.html","title":"Algae.Id","type":"module"},{"doc":"Default Elixir.Algae.Id struct","ref":"Algae.Id.html#new/0","title":"Algae.Id.new/0","type":"function"},{"doc":"Wrap some data in an Algae.Id wrapperExamplesiex&gt; new(42) %Algae.Id{id: 42}","ref":"Algae.Id.html#new/1","title":"Algae.Id.new/1","type":"function"},{"doc":"","ref":"Algae.Id.html#t:t/0","title":"Algae.Id.t/0","type":"type"},{"doc":"The sum of Algae.Maybe.Just and Algae.Maybe.Nothing. Maybe represents the presence or absence of something.Please note that nil is actually a value, as it can be passed to functions! nil is not bottom!Examplesiex&gt; [1,2,3] ...&gt; |&gt; List.first() ...&gt; |&gt; case do ...&gt; nil -&gt; new() ...&gt; head -&gt; new(head) ...&gt; end %Algae.Maybe.Just{just: 1} iex&gt; [] ...&gt; |&gt; List.first() ...&gt; |&gt; case do ...&gt; nil -&gt; new() ...&gt; head -&gt; new(head) ...&gt; end %Algae.Maybe.Nothing{}","ref":"Algae.Maybe.html","title":"Algae.Maybe","type":"module"},{"doc":"Extract a value from a Maybe, falling back to a set value in the Nothing case.Examplesiex&gt; from_maybe(%Algae.Maybe.Nothing{}, else: 42) 42 iex&gt; %Algae.Maybe.Just{just: 1955} |&gt; from_maybe(else: 42) 1955","ref":"Algae.Maybe.html#from_maybe/2","title":"Algae.Maybe.from_maybe/2","type":"function"},{"doc":"Alias for new(value, nothing: nil).Examplesiex&gt; from_nillable(9) %Algae.Maybe.Just{just: 9} iex&gt; from_nillable(nil) %Algae.Maybe.Nothing{}","ref":"Algae.Maybe.html#from_nillable/1","title":"Algae.Maybe.from_nillable/1","type":"function"},{"doc":"Put no value into the Maybe context (ie: make it a Nothing)Examplesiex&gt; new() %Algae.Maybe.Nothing{}","ref":"Algae.Maybe.html#new/0","title":"Algae.Maybe.new/0","type":"function"},{"doc":"","ref":"Algae.Maybe.html#new/1","title":"Algae.Maybe.new/1","type":"function"},{"doc":"Put a value into the Maybe context (ie: make it a Just)Examplesiex&gt; new(9) %Algae.Maybe.Just{just: 9} iex&gt; new(nil) %Algae.Maybe.Just{just: nil} iex&gt; new(nil, nothing: nil) %Algae.Maybe.Nothing{} iex&gt; new(9, nothing: 9) %Algae.Maybe.Nothing{} iex&gt; new(9, nothing: 1) %Algae.Maybe.Just{just: 9}","ref":"Algae.Maybe.html#new/2","title":"Algae.Maybe.new/2","type":"function"},{"doc":"","ref":"Algae.Maybe.html#t:t/0","title":"Algae.Maybe.t/0","type":"type"},{"doc":"","ref":"Algae.Maybe.Just.html","title":"Algae.Maybe.Just","type":"module"},{"doc":"Default Elixir.Algae.Maybe.Just struct. Value defaults to nil.","ref":"Algae.Maybe.Just.html#new/0","title":"Algae.Maybe.Just.new/0","type":"function"},{"doc":"Helper for initializing struct with a specific value","ref":"Algae.Maybe.Just.html#new/1","title":"Algae.Maybe.Just.new/1","type":"function"},{"doc":"","ref":"Algae.Maybe.Just.html#t:t/0","title":"Algae.Maybe.Just.t/0","type":"type"},{"doc":"","ref":"Algae.Maybe.Nothing.html","title":"Algae.Maybe.Nothing","type":"module"},{"doc":"Default Elixir.Algae.Maybe.Nothing struct","ref":"Algae.Maybe.Nothing.html#new/0","title":"Algae.Maybe.Nothing.new/0","type":"function"},{"doc":"","ref":"Algae.Maybe.Nothing.html#t:t/0","title":"Algae.Maybe.Nothing.t/0","type":"type"},{"doc":"Algae.Reader allows you to pass some readable context around through actions.This is useful in a number of situations, but the most common case is to weave access to environment variables monadically.For an illustrated guide to Readers, see Thee Useful Monads.Examplesiex&gt; use Witchcraft ...&gt; ...&gt; correct = ...&gt; monad %Algae.Reader{} do ...&gt; count &lt;- ask &amp;Map.get(&amp;1, :count) ...&gt; bindings &lt;- ask() ...&gt; return (count == Map.size(bindings)) ...&gt; end ...&gt; ...&gt; sample_bindings = %{count: 3, a: 1, b: 2} ...&gt; correct_count = run(correct, sample_bindings) ...&gt; &quot;Correct count for \#{inspect sample_bindings}? \#{correct_count}&quot; &quot;Correct count for %{a: 1, b: 2, count: 3}? true&quot; ...&gt; ...&gt; bad_bindings = %{count: 100, a: 1, b: 2} ...&gt; bad_count = run(correct, bad_bindings) ...&gt; &quot;Correct count for \#{inspect bad_bindings}? \#{bad_count}&quot; &quot;Correct count for %{a: 1, b: 2, count: 100}? false&quot;Example adapted from source","ref":"Algae.Reader.html","title":"Algae.Reader","type":"module"},{"doc":"Get the wrapped environment. Especially useful in monadic do-notation.Examplesiex&gt; run(ask(), 42) 42 iex&gt; use Witchcraft ...&gt; ...&gt; example_fun = ...&gt; fn x -&gt; ...&gt; monad %Algae.Reader{} do ...&gt; e &lt;- ask() ...&gt; return {x, e} ...&gt; end ...&gt; end ...&gt; ...&gt; 42 ...&gt; |&gt; example_fun.() ...&gt; |&gt; run(7) {42, 7}","ref":"Algae.Reader.html#ask/0","title":"Algae.Reader.ask/0","type":"function"},{"doc":"Similar to new/1 and ask/0. Construct an Algae.Reader, but apply a function to the constructed envoronment.The pun here is that you're &quot;asking&quot; a function for something.Examplesiex&gt; fn x -&gt; x * 10 end ...&gt; |&gt; ask() ...&gt; |&gt; run(5) 50 iex&gt; use Witchcraft ...&gt; ...&gt; foo = ...&gt; fn words -&gt; ...&gt; monad %Algae.Reader{} do ...&gt; loud &lt;- ask &amp;(&amp;1 == String.upcase(&amp;1)) ...&gt; return(words &lt;&gt; (if loud, do: &quot;!&quot;, else: &quot;.&quot;)) ...&gt; end ...&gt; end ...&gt; ...&gt; &quot;Hello&quot; |&gt; foo.() |&gt; run(&quot;WORLD&quot;) # &quot;WORLD&quot; is the context being asked for &quot;Hello!&quot;","ref":"Algae.Reader.html#ask/1","title":"Algae.Reader.ask/1","type":"function"},{"doc":"Locally composes a function into a Reader.Often the idea is to temporarily adapt the Reader without continuing this change in later runs.Examplesiex&gt; ask() ...&gt; |&gt; local(fn word -&gt; word &lt;&gt; &quot;!&quot; end) ...&gt; |&gt; local(&amp;String.upcase/1) ...&gt; |&gt; run(&quot;o hai thar&quot;) &quot;O HAI THAR!&quot;","ref":"Algae.Reader.html#local/2","title":"Algae.Reader.local/2","type":"function"},{"doc":"Default Elixir.Algae.Reader struct","ref":"Algae.Reader.html#new/0","title":"Algae.Reader.new/0","type":"function"},{"doc":"Reader constructor.Examplesiex&gt; newbie = new(fn x -&gt; x * 10 end) ...&gt; newbie.reader.(10) 100","ref":"Algae.Reader.html#new/1","title":"Algae.Reader.new/1","type":"function"},{"doc":"Run the reader function with some argument.iex&gt; reader = new(fn x -&gt; x + 5 end) ...&gt; run(reader, 42) 47This is the opposite of new/1.iex&gt; fun = fn x -&gt; x + 5 end ...&gt; fun.(42) == fun |&gt; new() |&gt; run(42) true","ref":"Algae.Reader.html#run/2","title":"Algae.Reader.run/2","type":"function"},{"doc":"","ref":"Algae.Reader.html#t:t/0","title":"Algae.Reader.t/0","type":"type"},{"doc":"Algae.State describes a wrapped function that can be used to pass around some &quot;hidden&quot; pure state.This has numerous applications, but the primary advantage is purity. The state gets passed around with the value, and the monadic DSL helps it feel more natural than passing everything around by hand.In many ways, Algae.State is a generalization of Algae.Reader and Algae.Writer. See Thee Useful Monads a nice, illustrated guide to how these work and relate.Anatomy # To pass in concrete values ↓ %Algae.State{runner: fn access -&gt; {value, state} end} ↑ ↑ # &quot;explicit&quot; value position &quot;hidden&quot; state positionExamplesiex&gt; use Witchcraft ...&gt; ...&gt; %Algae.State{} ...&gt; |&gt; monad do ...&gt; name &lt;- get() ...&gt; let result = &quot;Hello, \#{name}!&quot; ...&gt; ...&gt; put result ...&gt; modify &amp;String.upcase/1 ...&gt; ...&gt; return result ...&gt; end ...&gt; |&gt; run(&quot;world&quot;) { &quot;Hello, world!&quot;, &quot;HELLO, WORLD!&quot; } iex&gt; use Witchcraft ...&gt; ...&gt; pop = fn -&gt; state(fn([x | xs]) -&gt; {x, xs} end) end ...&gt; pull = fn -&gt; state(fn(list = [x | _]) -&gt; {x, list} end) end ...&gt; push = &amp;state(fn(xs) -&gt; {%Witchcraft.Unit{}, [&amp;1 | xs]} end) ...&gt; ...&gt; %Algae.State{} ...&gt; |&gt; monad do ...&gt; push.([&quot;a&quot;]) ...&gt; push.([&quot;b&quot;]) ...&gt; push.([&quot;c&quot;]) ...&gt; push.([&quot;d&quot;]) ...&gt; push.([&quot;e&quot;]) ...&gt; ...&gt; z &lt;- pop.() ...&gt; y &lt;- pop.() ...&gt; x &lt;- pop.() ...&gt; ...&gt; push.(x &lt;&gt; y &lt;&gt; z) ...&gt; pull.() ...&gt; end ...&gt; |&gt; evaluate([]) [&quot;c&quot;, &quot;d&quot;, &quot;e&quot;]","ref":"Algae.State.html","title":"Algae.State","type":"module"},{"doc":"Run the enclosed Algae.State runner, and return the value (no state).Examplesiex&gt; use Witchcraft ...&gt; ...&gt; %Algae.State{} ...&gt; |&gt; monad do ...&gt; name &lt;- get() ...&gt; put &quot;Ignored&quot; ...&gt; return &quot;Hello, \#{name}!&quot; ...&gt; end ...&gt; |&gt; evaluate(&quot;world&quot;) &quot;Hello, world!&quot;","ref":"Algae.State.html#evaluate/2","title":"Algae.State.evaluate/2","type":"function"},{"doc":"Run the enclosed Algae.State runner, and return the state (no value).Examplesiex&gt; fn x -&gt; x + 1 end ...&gt; |&gt; get() ...&gt; |&gt; execute(1) 1 iex&gt; use Witchcraft ...&gt; ...&gt; %Algae.State{} ...&gt; |&gt; monad do ...&gt; whatevs &lt;- get() ...&gt; put &quot;State&quot; ...&gt; return &quot;Hello, \#{whatevs}!&quot; ...&gt; end ...&gt; |&gt; execute(&quot;world&quot;) &quot;State&quot;","ref":"Algae.State.html#execute/2","title":"Algae.State.execute/2","type":"function"},{"doc":"Set both sides of an Algae.State struct.Examplesiex&gt; run(get(), 1) {1, 1}","ref":"Algae.State.html#get/0","title":"Algae.State.get/0","type":"function"},{"doc":"Set both sides of an Algae.State struct, plus running a function over the value portion of the inner state.Examplesiex&gt; fn x -&gt; x * 10 end ...&gt; |&gt; get() ...&gt; |&gt; run(4) {40, 4}","ref":"Algae.State.html#get/1","title":"Algae.State.get/1","type":"function"},{"doc":"Run a function over the &quot;state&quot; portion of the runner.Examplesiex&gt; fn x -&gt; x + 1 end ...&gt; |&gt; modify() ...&gt; |&gt; run(42) {%Witchcraft.Unit{}, 43} iex&gt; use Witchcraft ...&gt; ...&gt; %Algae.State{} ...&gt; |&gt; monad do ...&gt; name &lt;- get() ...&gt; ...&gt; put &quot;State&quot; ...&gt; modify &amp;String.upcase/1 ...&gt; ...&gt; return &quot;Hello, \#{name}!&quot; ...&gt; end ...&gt; |&gt; run(&quot;world&quot;) {&quot;Hello, world!&quot;, &quot;STATE&quot;}","ref":"Algae.State.html#modify/1","title":"Algae.State.modify/1","type":"function"},{"doc":"Construct a new Algae.State struct from a state runner in the form fn x -&gt; {y, z} endExamplesiex&gt; new(fn x -&gt; {x + 1, x} end).runner.(42) {43, 42}","ref":"Algae.State.html#new/1","title":"Algae.State.new/1","type":"function"},{"doc":"Set the stateful position of an Algae.Struct.Not unlike Algae.Writer.tell/1.Examplesiex&gt; 1 ...&gt; |&gt; put() ...&gt; |&gt; run(0) {%Witchcraft.Unit{}, 1}","ref":"Algae.State.html#put/1","title":"Algae.State.put/1","type":"function"},{"doc":"Extract the runner from an Algae.State.Can be used as a curried version of run/2.Examplesiex&gt; inner = fn x -&gt; {0, x} end ...&gt; ...&gt; run(%Algae.State{runner: inner}).(42) == inner.(42) true","ref":"Algae.State.html#run/1","title":"Algae.State.run/1","type":"function"},{"doc":"Run an Algae.State by passing in some initial state to actualy run the enclosed state runner.Examplesiex&gt; use Witchcraft ...&gt; ...&gt; %Algae.State{} ...&gt; |&gt; of(2) ...&gt; |&gt; run(0) {2, 0}","ref":"Algae.State.html#run/2","title":"Algae.State.run/2","type":"function"},{"doc":"Alias for new/1 that reads better when importing the module.Examplesiex&gt; state(fn x -&gt; {x + 1, x} end).runner.(42) {43, 42}","ref":"Algae.State.html#state/1","title":"Algae.State.state/1","type":"function"},{"doc":"","ref":"Algae.State.html#t:runner/0","title":"Algae.State.runner/0","type":"type"},{"doc":"","ref":"Algae.State.html#t:t/0","title":"Algae.State.t/0","type":"type"},{"doc":"Represent a BinarySearch tree.Examplesiex&gt; alias Algae.Tree.BinarySearch, as: BSTree ...&gt; ...&gt; BSTree.Node.new( ...&gt; 42, ...&gt; BSTree.Node.new(77), ...&gt; BSTree.Node.new( ...&gt; 1234, ...&gt; BSTree.Node.new(98), ...&gt; BSTree.Node.new(32) ...&gt; ) ...&gt; ) %Algae.Tree.BinarySearch.Node{ node: 42, left: %Algae.Tree.BinarySearch.Node{ node: 77, left: %Algae.Tree.BinarySearch.Empty{}, right: %Algae.Tree.BinarySearch.Empty{} }, right: %Algae.Tree.BinarySearch.Node{ node: 1234, left: %Algae.Tree.BinarySearch.Node{ node: 98, left: %Algae.Tree.BinarySearch.Empty{}, right: %Algae.Tree.BinarySearch.Empty{} }, right: %Algae.Tree.BinarySearch.Node{ node: 32, left: %Algae.Tree.BinarySearch.Empty{}, right: %Algae.Tree.BinarySearch.Empty{} } } }","ref":"Algae.Tree.BinarySearch.html","title":"Algae.Tree.BinarySearch","type":"module"},{"doc":"Remove an element from a tree by value.Examplesiex&gt; alias Algae.Tree.BinarySearch, as: BSTree ...&gt; ...&gt; BSTree.Node.new( ...&gt; 42, ...&gt; BSTree.Node.new(77), ...&gt; BSTree.Node.new( ...&gt; 1234, ...&gt; BSTree.Node.new(98), ...&gt; BSTree.Node.new(32) ...&gt; ) ...&gt; ) |&gt; delete(98) %Algae.Tree.BinarySearch.Node{ node: 42, left: %Algae.Tree.BinarySearch.Node{ node: 77 }, right: %Algae.Tree.BinarySearch.Node{ node: 1234, right: %Algae.Tree.BinarySearch.Node{ node: 32 } } }","ref":"Algae.Tree.BinarySearch.html#delete/2","title":"Algae.Tree.BinarySearch.delete/2","type":"function"},{"doc":"Build a BinarySearch tree from a list.Examplesiex&gt; Algae.Tree.BinarySearch.from_list([42, 77, 1234, 98, 32]) %Algae.Tree.BinarySearch.Node{ node: 42, left: %Algae.Tree.BinarySearch.Node{ node: 32 }, right: %Algae.Tree.BinarySearch.Node{ node: 77, right: %Algae.Tree.BinarySearch.Node{ node: 1234, left: %Algae.Tree.BinarySearch.Node{ node: 98 } } } }","ref":"Algae.Tree.BinarySearch.html#from_list/1","title":"Algae.Tree.BinarySearch.from_list/1","type":"function"},{"doc":"Build a BinarySearch tree from a list and attach to an existing tree.Examplesiex&gt; Algae.Tree.BinarySearch.from_list([42, 77, 1234, 98, 32], new(-9)) %Algae.Tree.BinarySearch.Node{ node: -9, right: %Algae.Tree.BinarySearch.Node{ left: %Algae.Tree.BinarySearch.Node{ node: 32 }, node: 42, right: %Algae.Tree.BinarySearch.Node{ node: 77, right: %Algae.Tree.BinarySearch.Node{ node: 1234, left: %Algae.Tree.BinarySearch.Node{ node: 98 }, right: %Algae.Tree.BinarySearch.Empty{} } } } }","ref":"Algae.Tree.BinarySearch.html#from_list/2","title":"Algae.Tree.BinarySearch.from_list/2","type":"function"},{"doc":"Insert a new element into a tree.Examplesiex&gt; insert(new(42), 43) %Algae.Tree.BinarySearch.Node{ node: 42, right: %Algae.Tree.BinarySearch.Node{ node: 43 } }","ref":"Algae.Tree.BinarySearch.html#insert/2","title":"Algae.Tree.BinarySearch.insert/2","type":"function"},{"doc":"Create an empty tree.Examplesiex&gt; new() %Algae.Tree.BinarySearch.Empty{}","ref":"Algae.Tree.BinarySearch.html#new/0","title":"Algae.Tree.BinarySearch.new/0","type":"function"},{"doc":"Bring a value into an otherwise empty tree.Examplesiex&gt; new(42) %Algae.Tree.BinarySearch.Node{ node: 42, left: %Algae.Tree.BinarySearch.Empty{}, right: %Algae.Tree.BinarySearch.Empty{} }","ref":"Algae.Tree.BinarySearch.html#new/1","title":"Algae.Tree.BinarySearch.new/1","type":"function"},{"doc":"Flatten a tree into a list.Examplesiex&gt; alias Algae.Tree.BinarySearch, as: BSTree ...&gt; ...&gt; BSTree.Node.new( ...&gt; 42, ...&gt; BSTree.Node.new(77), ...&gt; BSTree.Node.new( ...&gt; 1234, ...&gt; BSTree.Node.new(98), ...&gt; BSTree.Node.new(32) ...&gt; ) ...&gt; ) ...&gt; |&gt; BSTree.to_list() [42, 77, 1234, 98, 32]","ref":"Algae.Tree.BinarySearch.html#to_list/1","title":"Algae.Tree.BinarySearch.to_list/1","type":"function"},{"doc":"Flatten a tree into a list with elements sorted.Examplesiex&gt; alias Algae.Tree.BinarySearch, as: BSTree ...&gt; ...&gt; BSTree.Node.new( ...&gt; 42, ...&gt; BSTree.Node.new(77), ...&gt; BSTree.Node.new( ...&gt; 1234, ...&gt; BSTree.Node.new(98), ...&gt; BSTree.Node.new(32) ...&gt; ) ...&gt; ) ...&gt; |&gt; BSTree.to_ordered_list() [32, 42, 77, 98, 1234]","ref":"Algae.Tree.BinarySearch.html#to_ordered_list/1","title":"Algae.Tree.BinarySearch.to_ordered_list/1","type":"function"},{"doc":"","ref":"Algae.Tree.BinarySearch.html#t:t/0","title":"Algae.Tree.BinarySearch.t/0","type":"type"},{"doc":"","ref":"Algae.Tree.BinarySearch.Empty.html","title":"Algae.Tree.BinarySearch.Empty","type":"module"},{"doc":"Default Elixir.Algae.Tree.BinarySearch.Empty struct","ref":"Algae.Tree.BinarySearch.Empty.html#new/0","title":"Algae.Tree.BinarySearch.Empty.new/0","type":"function"},{"doc":"","ref":"Algae.Tree.BinarySearch.Empty.html#t:t/0","title":"Algae.Tree.BinarySearch.Empty.t/0","type":"type"},{"doc":"","ref":"Algae.Tree.BinarySearch.Node.html","title":"Algae.Tree.BinarySearch.Node","type":"module"},{"doc":"Positional constructor, with args in the same order as they were defined in","ref":"Algae.Tree.BinarySearch.Node.html#new/3","title":"Algae.Tree.BinarySearch.Node.new/3","type":"function"},{"doc":"","ref":"Algae.Tree.BinarySearch.Node.html#new_partial/0","title":"Algae.Tree.BinarySearch.Node.new_partial/0","type":"function"},{"doc":"","ref":"Algae.Tree.BinarySearch.Node.html#new_partial/1","title":"Algae.Tree.BinarySearch.Node.new_partial/1","type":"function"},{"doc":"","ref":"Algae.Tree.BinarySearch.Node.html#new_partial/2","title":"Algae.Tree.BinarySearch.Node.new_partial/2","type":"function"},{"doc":"","ref":"Algae.Tree.BinarySearch.Node.html#new_partial/3","title":"Algae.Tree.BinarySearch.Node.new_partial/3","type":"function"},{"doc":"","ref":"Algae.Tree.BinarySearch.Node.html#t:t/0","title":"Algae.Tree.BinarySearch.Node.t/0","type":"type"},{"doc":"A tree with any number of nodes at each levelExamples%Algae.Tree.Rose{ rose: 42, forest: [ %Algae.Tree.Rose{ rose: &quot;hi&quot; }, %Algae.Tree.Rose{ forest: [ %Algae.Tree.Rose{ rose: 0.4 } ] }, %Algae.Tree.Rose{ rose: &quot;there&quot; } ] }","ref":"Algae.Tree.Rose.html","title":"Algae.Tree.Rose","type":"module"},{"doc":"Wrap another tree around an existing one, relegating it to the forest.Examplesiex&gt; 55 ...&gt; |&gt; new() ...&gt; |&gt; layer(42) ...&gt; |&gt; layer(99) ...&gt; |&gt; layer(6) %Algae.Tree.Rose{ rose: 6, forest: [ %Algae.Tree.Rose{ rose: 99, forest: [ %Algae.Tree.Rose{ rose: 42, forest: [ %Algae.Tree.Rose{ rose: 55 } ] } ] } ] }","ref":"Algae.Tree.Rose.html#layer/2","title":"Algae.Tree.Rose.layer/2","type":"function"},{"doc":"Create a simple Algae.Rose tree, with an empty forest and one rose.Examplesiex&gt; new(42) %Algae.Tree.Rose{ rose: 42, forest: [] }","ref":"Algae.Tree.Rose.html#new/1","title":"Algae.Tree.Rose.new/1","type":"function"},{"doc":"Create an Algae.Rose tree, passing a forest and a rose.Examplesiex&gt; new(42, [new(55), new(14)]) %Algae.Tree.Rose{ rose: 42, forest: [ %Algae.Tree.Rose{rose: 55}, %Algae.Tree.Rose{rose: 14} ] }","ref":"Algae.Tree.Rose.html#new/2","title":"Algae.Tree.Rose.new/2","type":"function"},{"doc":"","ref":"Algae.Tree.Rose.html#new_partial/0","title":"Algae.Tree.Rose.new_partial/0","type":"function"},{"doc":"","ref":"Algae.Tree.Rose.html#new_partial/1","title":"Algae.Tree.Rose.new_partial/1","type":"function"},{"doc":"","ref":"Algae.Tree.Rose.html#new_partial/2","title":"Algae.Tree.Rose.new_partial/2","type":"function"},{"doc":"","ref":"Algae.Tree.Rose.html#t:forest/0","title":"Algae.Tree.Rose.forest/0","type":"type"},{"doc":"","ref":"Algae.Tree.Rose.html#t:rose/0","title":"Algae.Tree.Rose.rose/0","type":"type"},{"doc":"","ref":"Algae.Tree.Rose.html#t:t/0","title":"Algae.Tree.Rose.t/0","type":"type"},{"doc":"Algae.Writer helps capture the pattern of writing to a pure log or accumulated value, handling the bookkeeping for you.If Algae.Reader is quasi-read-only, Algae.Writer is quasi-write-only. This is often used for loggers, but could be anything as long as the hidden value is a Witchcraft.Monoid.There are many applications of Writers, but as an illustrative point, one could use it for logging across processes and time, since the log is carried around with the result in a pure fashion. The monadic DSL helps make using these feel more natural.For an illustrated guide to Writers, see Thee Useful Monads.Anatomy %Algae.Writer{writer: {value, log}} ↑ ↑ # &quot;explicit&quot; value position &quot;hidden&quot; position, # commonly used as a logExamplesiex&gt; use Witchcraft ...&gt; ...&gt; excite = ...&gt; fn string -&gt; ...&gt; monad writer({0.0, &quot;log&quot;}) do ...&gt; tell string ...&gt; ...&gt; excited &lt;- return &quot;\#{string}!&quot; ...&gt; tell &quot; =&gt; \#{excited} ... &quot; ...&gt; ...&gt; return excited ...&gt; end ...&gt; end ...&gt; ...&gt; {_, logs} = ...&gt; &quot;Hi&quot; ...&gt; |&gt; excite.() ...&gt; &gt;&gt;&gt; excite ...&gt; &gt;&gt;&gt; excite ...&gt; |&gt; censor(&amp;String.trim_trailing(&amp;1, &quot; ... &quot;)) ...&gt; |&gt; run() ...&gt; ...&gt; logs &quot;Hi =&gt; Hi! ... Hi! =&gt; Hi!! ... Hi!! =&gt; Hi!!!&quot; iex&gt; use Witchcraft ...&gt; ...&gt; exponent = ...&gt; fn num -&gt; ...&gt; monad writer({0, 0}) do ...&gt; tell 1 ...&gt; return num * num ...&gt; end ...&gt; end ...&gt; ...&gt; initial = 42 ...&gt; {result, times} = run(exponent.(initial) &gt;&gt;&gt; exponent &gt;&gt;&gt; exponent) ...&gt; ...&gt; &quot;\#{initial}^\#{round(:math.pow(2, times))} = \#{result}&quot; &quot;42^8 = 9682651996416&quot;","ref":"Algae.Writer.html","title":"Algae.Writer","type":"module"},{"doc":"Run a writer, and run a function over the resulting log.Examplesiex&gt; 42 ...&gt; |&gt; new([&quot;hi&quot;, &quot;THERE&quot;, &quot;friend&quot;]) ...&gt; |&gt; censor(&amp;Enum.reject(&amp;1, fn log -&gt; String.upcase(log) == log end)) ...&gt; |&gt; run() {42, [&quot;hi&quot;, &quot;friend&quot;]} iex&gt; use Witchcraft ...&gt; ...&gt; 0 ...&gt; |&gt; new([&quot;logs&quot;]) ...&gt; |&gt; monad do ...&gt; tell [&quot;Start&quot;] ...&gt; tell [&quot;BANG!&quot;] ...&gt; tell [&quot;shhhhhhh...&quot;] ...&gt; tell [&quot;LOUD NOISES!!!&quot;] ...&gt; tell [&quot;End&quot;] ...&gt; ...&gt; return 42 ...&gt; end ...&gt; |&gt; censor(&amp;Enum.reject(&amp;1, fn log -&gt; String.upcase(log) == log end)) ...&gt; |&gt; run() {42, [&quot;Start&quot;, &quot;shhhhhhh...&quot;, &quot;End&quot;]}","ref":"Algae.Writer.html#censor/2","title":"Algae.Writer.censor/2","type":"function"},{"doc":"Copy the log into the value position. This makes it accessible in do-notation.Examplesiex&gt; listen(%Algae.Writer{writer: {42, &quot;hi&quot;}}) %Algae.Writer{writer: {{42, &quot;hi&quot;}, &quot;hi&quot;}} iex&gt; use Witchcraft ...&gt; ...&gt; monad new(1, 1) do ...&gt; wr &lt;- listen tell(42) ...&gt; tell 43 ...&gt; return wr ...&gt; end %Algae.Writer{ writer: {{%Witchcraft.Unit{}, 42}, 85} }","ref":"Algae.Writer.html#listen/1","title":"Algae.Writer.listen/1","type":"function"},{"doc":"Similar to listen/1, but with the ability to adjust the copied log.Examplesiex&gt; listen(%Algae.Writer{writer: {1, &quot;hi&quot;}}, &amp;String.upcase/1) %Algae.Writer{ writer: {{1, &quot;HI&quot;}, &quot;hi&quot;} }","ref":"Algae.Writer.html#listen/2","title":"Algae.Writer.listen/2","type":"function"},{"doc":"Construct a Algae.Writer struct from a starting value and log.Examplesiex&gt; new() %Algae.Writer{writer: {0, []}} iex&gt; new(&quot;hi&quot;) %Algae.Writer{writer: {&quot;hi&quot;, []}} iex&gt; new(&quot;ohai&quot;, 42) %Algae.Writer{writer: {&quot;ohai&quot;, 42}}","ref":"Algae.Writer.html#new/2","title":"Algae.Writer.new/2","type":"function"},{"doc":"Run a function in the value portion of an Algae.Writer on the log.Notice that the structure is similar to what somes out of listen/{1,2}Algae.Writer{writer: {{_, function}, log}}Examplesiex&gt; pass(%Algae.Writer{writer: {{1, fn x -&gt; x * 10 end}, 42}}) %Algae.Writer{writer: {1, 420}} iex&gt; use Witchcraft ...&gt; ...&gt; monad new(&quot;string&quot;, [&quot;logs&quot;]) do ...&gt; a &lt;- [&quot;start&quot;] |&gt; tell() |&gt; listen() ...&gt; tell [&quot;middle&quot;] ...&gt; ...&gt; {value, logs} &lt;- return a ...&gt; pass writer({{value, fn [log | _] -&gt; [log | [log | logs]] end}, logs}) ...&gt; ...&gt; tell [&quot;next is 42&quot;] ...&gt; return 42 ...&gt; end %Algae.Writer{ writer: {42, [&quot;start&quot;, &quot;middle&quot;, &quot;start&quot;, &quot;start&quot;, &quot;start&quot;, &quot;next is 42&quot;]} }","ref":"Algae.Writer.html#pass/1","title":"Algae.Writer.pass/1","type":"function"},{"doc":"Extract the enclosed value and log from an Algae.Writer.Examplesiex&gt; run(%Algae.Writer{writer: {&quot;hi&quot;, &quot;there&quot;}}) {&quot;hi&quot;, &quot;there&quot;} iex&gt; use Witchcraft ...&gt; ...&gt; half = ...&gt; fn num -&gt; ...&gt; monad writer({0.0, [&quot;log&quot;]}) do ...&gt; let half = num / 2 ...&gt; tell [&quot;\#{num} / 2 = \#{half}&quot;] ...&gt; return half ...&gt; end ...&gt; end ...&gt; ...&gt; run(half.(42) &gt;&gt;&gt; half &gt;&gt;&gt; half) { 5.25, [ &quot;42 / 2 = 21.0&quot;, &quot;21.0 / 2 = 10.5&quot;, &quot;10.5 / 2 = 5.25&quot; ] }","ref":"Algae.Writer.html#run/1","title":"Algae.Writer.run/1","type":"function"},{"doc":"Set the &quot;log&quot; portion of an Algae.Writer stepExamplesiex&gt; tell(&quot;secrets&quot;) %Algae.Writer{writer: {%Witchcraft.Unit{}, &quot;secrets&quot;}} iex&gt; use Witchcraft ...&gt; ...&gt; monad %Algae.Writer{writer: {&quot;string&quot;, 1}} do ...&gt; tell 42 ...&gt; tell 43 ...&gt; return &quot;hey&quot; ...&gt; end %Algae.Writer{writer: {&quot;hey&quot;, 85}} iex&gt; use Witchcraft ...&gt; ...&gt; half = ...&gt; fn num -&gt; ...&gt; monad writer({0.0, [&quot;log&quot;]}) do ...&gt; let half = num / 2 ...&gt; tell [&quot;\#{num} / 2 = \#{half}&quot;] ...&gt; return half ...&gt; end ...&gt; end ...&gt; ...&gt; run(half.(42.0) &gt;&gt;&gt; half &gt;&gt;&gt; half) { 5.25, [ &quot;42.0 / 2 = 21.0&quot;, &quot;21.0 / 2 = 10.5&quot;, &quot;10.5 / 2 = 5.25&quot; ] }","ref":"Algae.Writer.html#tell/1","title":"Algae.Writer.tell/1","type":"function"},{"doc":"Similar to new/2, but taking a tuple rather than separate fields.Examplesiex&gt; writer({&quot;ohai&quot;, 42}) %Algae.Writer{writer: {&quot;ohai&quot;, 42}}","ref":"Algae.Writer.html#writer/1","title":"Algae.Writer.writer/1","type":"function"},{"doc":"","ref":"Algae.Writer.html#t:log/0","title":"Algae.Writer.log/0","type":"type"},{"doc":"","ref":"Algae.Writer.html#t:t/0","title":"Algae.Writer.t/0","type":"type"},{"doc":"","ref":"Algae.Writer.html#t:value/0","title":"Algae.Writer.value/0","type":"type"},{"doc":"","ref":"Algae.Writer.html#t:writer/0","title":"Algae.Writer.writer/0","type":"type"},{"doc":"","ref":"Algae.Internal.NeedsExplicitDefaultError.html","title":"Algae.Internal.NeedsExplicitDefaultError","type":"exception"},{"doc":"Algae provides a boilerplate-avoiding DSL for defining algebraic data types (ADTs), plus several common structuresQuickstartAdd Algae to your list of dependencies in mix.exs: def deps do [{:algae, &quot;~&gt; 1.2&quot;}] end Table of ContentsProduct BuilderDefinition DSLConstructorEmpty TagSum BuilderDefault ConstructorTagged UnionsA Sampling of ADTsIdMaybeTree.BinarySearchNOTEPlease import Algae before trying out the examples below. The samples assume that is has already been done to remove the unnecessary clutter.Product BuilderBuild a product typeIncludes:StructType definitionConstructor function (for piping and defaults)Implicit defaults for simple values","ref":"readme.html","title":"Quickstart","type":"extras"},{"doc":"For convenience, several variants of the DSL are available.Standarddefmodule Player do # =============== # # Data Definition # # =============== # defdata do name :: String.t() hit_points :: non_neg_integer() experience :: non_neg_integer() end # =================== # # Rest of Module # # (business as usual) # # =================== # @spec attack(t(), t()) :: {t(), t()} def attack(%{experience: xp} = player, %{hit_points: hp} = target) do { %{player | experience: xp + 50}, %{target | hit_points: hp - 10} } end end #=&gt; %Player{name: &quot;Sir Bob&quot;, hit_points: 10, experience: 500}Single Field ShorthandWithout any fields specified, Algae will default to a single field with the same name as the module (essentially a &quot;wrapper type&quot;). You must still provide the type for this field, however.Embedded in another module:defmodule Id do defdata any() end %Id{} #=&gt; %Id{id: nil}Standalone:defdata Wrapper :: any() %Wrapper{} #=&gt; %Wrapper{wrapper: nil}","ref":"readme.html#definition-dsl","title":"Quickstart - Definition DSL","type":"extras"},{"doc":"A helper function, especially useful for piping. The order of arguments is the same as the order that they are defined in.defmodule Person do defdata do name :: String.t() age :: non_neg_integer() end end Person.new(&quot;Rachel Weintraub&quot;) #=&gt; %Person{ # name: &quot;Rachel Weintraub&quot;, # age: 0 # }Constructor DefaultsFields will automatically default to a sensible value (a typical &quot;zero&quot; for that datatype). For example, non_neg_integer() will default to 0, and String.t() will default to &quot;&quot;.You may also overwrite these defaults with the \\\\ syntax.defmodule Pet do defdata do name :: String.t() leg_count :: non_neg_integer() \\\\ 4 end end Pet.new(&quot;Crookshanks&quot;) #=&gt; %Pet{ # name: &quot;Crookshanks&quot;, # leg_count: 4 # } Pet.new(&quot;Paul the Psychic Octopus&quot;, 8) #=&gt; %Pet{ # name: &quot;Paul the Psychic Octopus&quot;, # leg_count: 8 # }This overwriting syntax is required for complex types:defdata Grocery do item :: {String.t(), integer(), boolean()} \\\\ {&quot;Orange&quot;, 4, false} end Grocery.new() #=&gt; %Grocery{ # item: {&quot;Orange&quot;, 4, false} # }Overwrite ConstructorThe new constructor function may be overwritten.defmodule Constant do defdata :: fun() def new(value), do: %Constant{constant: fn _ -&gt; value end} end fourty_two = Constant.new(42) fourty_two.constant.(33) #=&gt; 42","ref":"readme.html#constructor","title":"Quickstart - Constructor","type":"extras"},{"doc":"An empty type (with no fields) is definable using the none() typedefmodule Nothing do defdata none() end Nothing.new() #=&gt; %Nothing{}Sum BuilderBuild a sum (coproduct) type from product typesdefmodule Light do # ============== # # Sum Definition # # ============== # defsum do defdata Red :: none() defdata Yellow :: none() defdata Green :: none() end # =================== # # Rest of Module # # (business as usual) # # =================== # def from_number(1), do: %Light.Red{} def from_number(2), do: %Light.Yellow{} def from_number(3), do: %Light.Green{} end Light.new() #=&gt; %Light.Red{}","ref":"readme.html#empty-tag","title":"Quickstart - Empty Tag","type":"extras"},{"doc":"Data with multiple fields can be defined directly as part of a sumdefmodule Pet do defsum do defdata Cat do name :: String.t() claw_sharpness :: String.t() end defdata Dog do name :: String.t() bark_loudness :: non_neg_integer() end end end","ref":"readme.html#embedded-products","title":"Quickstart - Embedded Products","type":"extras"},{"doc":"The first defdata's constructor will be the default constructor for the sumdefmodule Maybe do defsum do defdata Nothing :: none() defdata Just :: any() end end Maybe.new() #=&gt; %Maybe.Nothing{}","ref":"readme.html#default-constructor","title":"Quickstart - Default Constructor","type":"extras"},{"doc":"Sums join existing types with tags: new types to help distinguish the context that they are in (the sum type)defdata Book :: String.t() \\\\ &quot;War and Peace&quot; defdata Video :: String.t() \\\\ &quot;2001: A Space Odyssey&quot; defmodule Media do defsum do defdata Paper :: Book.t() defdata Film :: Video.t() \\\\ Video.new(&quot;A Clockwork Orange&quot;) end end media = Media.new() #=&gt; %Paper{ # paper: %Book{ # book: &quot;War and Peace&quot; # } # }A Sampling of ADTsSee complete docs for more","ref":"readme.html#tagged-unions","title":"Quickstart - Tagged Unions","type":"extras"},{"doc":"The simplest ADT: a simple wrapper for some data%Algae.Id{id: &quot;hi!&quot;}","ref":"readme.html#algae-id","title":"Quickstart - Algae.Id","type":"extras"},{"doc":"Maybe represents the presence or absence of something.Please note that nil is actually a value, as it can be passed to functions! nil is not bottom!Algae.Maybe.new() #=&gt; %Algae.Maybe.Nothing{} Algae.Maybe.new(42) #=&gt; %Algae.Maybe.Just{just: 42}","ref":"readme.html#algae-maybe","title":"Quickstart - Algae.Maybe","type":"extras"},{"doc":"alias Algae.Tree.BinarySearch, as: BTree # 42 # / \\ # 77 1234 # / \\ # 98 32 BTree.Branch.new( 42, BTree.Branch.new(77), BTree.Branch.new( 1234, BTree.Branch.new(98), BTree.Branch.new(32) ) ) #=&gt; %Algae.Tree.BinarySearch.Branch{ # value: 42, # left: %Algae.Tree.BinarySearch.Branch{ # value: 77, # left: %Algae.Tree.BinarySearch.Empty{}, # right: %Algae.Tree.BinarySearch.Empty{} # }, # right: %Algae.Tree.BinarySearch.Branch{ # value: 1234, # left: %Algae.Tree.BinarySearch.Branch{ # value: 98, # left: %Algae.Tree.BinarySearch.Empty{}, # right: %Algae.Tree.BinarySearch.Empty{} # }, # right: %Algae.Tree.BinarySearch.Branch{ # value: 32, # left: %Algae.Tree.BinarySearch.Empty{}, # right: %Algae.Tree.BinarySearch.Empty{} # } # } # }","ref":"readme.html#tree-binarysearch","title":"Quickstart - Tree.BinarySearch","type":"extras"}]